Index: branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork.cs	(revision 14619)
+++ branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork.cs	(revision 14621)
@@ -31,5 +31,5 @@
   [Item("TtpNetwork", "An abstract base class for TTP optimization networks.")]
   [StorableClass]
-  public abstract class TtpNetwork : Network {
+  public abstract class TtpNetwork : Network, IOptimizer {
     #region Constants
     protected const string OrchestratorNodeName = "Orchestrator";
@@ -104,11 +104,11 @@
       if (algorithm == null) return;
 
-      algorithm.ExecutionStateChanged += OnExecutionStateChanged;
-      algorithm.ExecutionTimeChanged += OnExecutionTimeChanged;
-      algorithm.Prepared += OnPrepared;
-      algorithm.Started += OnStarted;
-      algorithm.Paused += OnPaused;
-      algorithm.Stopped += OnStopped;
-      algorithm.ExceptionOccurred += OnExceptionOccurred;
+      algorithm.ExecutionStateChanged += (s, e) => OnExecutionStateChanged();
+      algorithm.ExecutionTimeChanged += (s, e) => OnExecutionTimeChanged();
+      algorithm.Prepared += (s, e) => OnPrepared();
+      algorithm.Started += (s, e) => OnStarted();
+      algorithm.Paused += (s, e) => OnPaused();
+      algorithm.Stopped += (s, e) => OnStopped();
+      algorithm.ExceptionOccurred += (s, e) => OnExceptionOccurred(e.Value);
     }
 
@@ -167,12 +167,4 @@
     }
     #endregion
-
-    protected void OnExecutionStateChanged(object sender, EventArgs e) { OnExecutionStateChanged(); }
-    protected void OnExecutionTimeChanged(object sender, EventArgs e) { OnExecutionTimeChanged(); }
-    protected void OnPrepared(object sender, EventArgs e) { OnPrepared(); }
-    protected void OnStarted(object sender, EventArgs e) { OnStarted(); }
-    protected void OnPaused(object sender, EventArgs e) { OnPaused(); }
-    protected void OnStopped(object sender, EventArgs e) { OnStopped(); }
-    protected void OnExceptionOccurred(object sender, EventArgs<Exception> e) { OnExceptionOccurred(e.Value); }
   }
 }
Index: branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork1.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork1.cs	(revision 14619)
+++ branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork1.cs	(revision 14621)
@@ -25,5 +25,4 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -32,5 +31,5 @@
   [Creatable("Optimization Networks")]
   [StorableClass]
-  public sealed class TtpNetwork1 : TtpNetwork, IOptimizer {
+  public sealed class TtpNetwork1 : TtpNetwork {
     [StorableConstructor]
     private TtpNetwork1(bool deserializing) : base(deserializing) { }
Index: branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork2.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork2.cs	(revision 14619)
+++ branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork2.cs	(revision 14621)
@@ -25,5 +25,4 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -32,5 +31,5 @@
   [Creatable("Optimization Networks")]
   [StorableClass]
-  public sealed class TtpNetwork2 : TtpNetwork, IOptimizer {
+  public sealed class TtpNetwork2 : TtpNetwork {
     [StorableConstructor]
     private TtpNetwork2(bool deserializing) : base(deserializing) { }
Index: branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork3.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork3.cs	(revision 14619)
+++ branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork3.cs	(revision 14621)
@@ -25,5 +25,4 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -32,5 +31,5 @@
   [Creatable("Optimization Networks")]
   [StorableClass]
-  public sealed class TtpNetwork3 : TtpNetwork, IOptimizer {
+  public sealed class TtpNetwork3 : TtpNetwork {
     [StorableConstructor]
     private TtpNetwork3(bool deserializing) : base(deserializing) { }
Index: branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpOrchestratorNode.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpOrchestratorNode.cs	(revision 14619)
+++ branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpOrchestratorNode.cs	(revision 14621)
@@ -199,5 +199,5 @@
     }
 
-    protected void InstanceParameter_Value_ToStringChanged(object sender, EventArgs e) {
+    private void InstanceParameter_Value_ToStringChanged(object sender, EventArgs e) {
       string filePath = InstanceParameter.Value.Value;
       TtpUtils.Import(filePath, out tspCoordinates, out distanceType,