Index: /branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization/3.3/OrchestratedAlgorithmNode.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization/3.3/OrchestratedAlgorithmNode.cs	(revision 14623)
+++ /branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization/3.3/OrchestratedAlgorithmNode.cs	(revision 14624)
@@ -65,10 +65,12 @@
     [StorableConstructor]
     protected OrchestratedAlgorithmNode(bool deserializing) : base(deserializing) { }
-    protected OrchestratedAlgorithmNode(OrchestratedAlgorithmNode original, Cloner cloner) : base(original, cloner) {
+    protected OrchestratedAlgorithmNode(OrchestratedAlgorithmNode original, Cloner cloner)
+      : base(original, cloner) {
       EvalHook = cloner.Clone(original.EvalHook);
       RegisterEvents();
     }
     public OrchestratedAlgorithmNode() : this("OrchestratedAlgorithmNode") { }
-    public OrchestratedAlgorithmNode(string name) : base(name) {
+    public OrchestratedAlgorithmNode(string name)
+      : base(name) {
       var orchestrationPort = new MessagePort(OrchestrationPortName);
       Ports.Add(orchestrationPort);
@@ -95,8 +97,9 @@
     #region Port Events
     private void OrchestrationPort_MessageReceived(object sender, EventArgs<IMessage, CancellationToken> e) {
-      var message = ((EnumValue<OrchestrationMessage>)e.Value["OrchestrationMessage"]).Value;
+      var message = e.Value;
+      var orchestrationMessage = ((EnumValue<OrchestrationMessage>)message["OrchestrationMessage"]).Value;
 
       #region Prepare
-      if (message.HasFlag(OrchestrationMessage.Prepare)) {
+      if (orchestrationMessage.HasFlag(OrchestrationMessage.Prepare)) {
         switch (Algorithm.ExecutionState) {
           case ExecutionState.Prepared:
@@ -107,5 +110,5 @@
               var prob = (IHeuristicOptimizationProblem)problemMsgVal.Value.Clone();
 
-              if (message.HasFlag(OrchestrationMessage.SetEvalHook)) {
+              if (orchestrationMessage.HasFlag(OrchestrationMessage.SetEvalHook)) {
                 var instEval = prob.Evaluator as InstrumentedOperator;
                 if (instEval != null && EvalHook != null) instEval.AfterExecutionOperators.Add(EvalHook);
@@ -137,5 +140,5 @@
               }
 
-              Algorithm.Prepare(message.HasFlag(OrchestrationMessage.ClearRuns));
+              Algorithm.Prepare(orchestrationMessage.HasFlag(OrchestrationMessage.ClearRuns));
             }
             break;
@@ -145,5 +148,5 @@
 
       #region Start
-      if (message.HasFlag(OrchestrationMessage.Start)) {
+      if (orchestrationMessage.HasFlag(OrchestrationMessage.Start)) {
         switch (Algorithm.ExecutionState) {
           case ExecutionState.Prepared:
@@ -172,4 +175,5 @@
 
             if (sendResultMessage) {
+              message["Results"] = (ResultCollection)Algorithm.Results.Clone();
               var msg = OrchestrationPort.PrepareMessage();
               msg["Results"] = (ResultCollection)Algorithm.Results.Clone();
@@ -182,10 +186,11 @@
 
       #region Pause
-      if (message.HasFlag(OrchestrationMessage.Pause)) {
+      if (orchestrationMessage.HasFlag(OrchestrationMessage.Pause)) {
         if (Algorithm.ExecutionState == ExecutionState.Started) {
           sendResultMessage = false;
           try {
             Algorithm.Pause();
-          } catch (InvalidOperationException) {
+          }
+          catch (InvalidOperationException) {
             // ExecutionState might have changed since we accepted the message
           }
@@ -195,5 +200,5 @@
 
       #region Stop
-      if (message.HasFlag(OrchestrationMessage.Stop)) {
+      if (orchestrationMessage.HasFlag(OrchestrationMessage.Stop)) {
         switch (Algorithm.ExecutionState) {
           case ExecutionState.Started:
@@ -201,7 +206,9 @@
             try {
               Algorithm.Stop();
-            } catch (InvalidOperationException) {
+            }
+            catch (InvalidOperationException) {
               // ExecutionState might have changed since we accepted the message
-            } catch (NullReferenceException) {
+            }
+            catch (NullReferenceException) {
               // BasicAlgorithm might have stopped since we accepted the message
               // CancellationTokenSource is null in this case
Index: /branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization/3.3/OrchestratorNode.cs
===================================================================
--- /branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization/3.3/OrchestratorNode.cs	(revision 14623)
+++ /branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization/3.3/OrchestratorNode.cs	(revision 14624)
@@ -35,8 +35,9 @@
   [StorableClass]
   public abstract class OrchestratorNode : Node, IOrchestratorNode {
+    //TODO remove suffixes
     #region Constants
     protected const string OrchestrationMessageParameterName = "OrchestrationMessage";
-    protected const string OrchestrationPortNameSuffix = "OrchestrationPort";
-    protected const string EvaluationPortNameSuffix = "EvaluationPort";
+    protected const string OrchestrationPortNameSuffix = "";
+    protected const string EvaluationPortNameSuffix = "";
     #endregion
 
@@ -62,5 +63,6 @@
     [StorableConstructor]
     protected OrchestratorNode(bool deserializing) : base(deserializing) { }
-    protected OrchestratorNode(OrchestratorNode original, Cloner cloner) : base(original, cloner) {
+    protected OrchestratorNode(OrchestratorNode original, Cloner cloner)
+      : base(original, cloner) {
       results = cloner.Clone(original.results);
       parameters = cloner.Clone(original.parameters);
@@ -69,5 +71,6 @@
     }
 
-    protected OrchestratorNode() : base("OrchestratorNode") {
+    protected OrchestratorNode()
+      : base("OrchestratorNode") {
       results = new ResultCollection();
       parameters = new ParameterCollection();
@@ -75,5 +78,6 @@
       readOnlyParameters = null;
     }
-    protected OrchestratorNode(string name) : base(name) {
+    protected OrchestratorNode(string name)
+      : base(name) {
       results = new ResultCollection();
       parameters = new ParameterCollection();
@@ -81,5 +85,6 @@
       readOnlyParameters = null;
     }
-    protected OrchestratorNode(string name, string description) : base(name, description) {
+    protected OrchestratorNode(string name, string description)
+      : base(name, description) {
       results = new ResultCollection();
       parameters = new ParameterCollection();