Index: branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/Problems/LootProfitProblem.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/Problems/LootProfitProblem.cs	(revision 14628)
+++ branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/Problems/LootProfitProblem.cs	(revision 14629)
@@ -79,6 +79,6 @@
     public override double Evaluate(BinaryVector vector, IRandom random) {
       return TtpUtils.Evaluate(Tsp, FixedTspSolution.ToArray(),
-                                  Ksp, vector.ToArray(),
-                                  Availability, RentingRatio, MinSpeed, MaxSpeed, DistanceType);
+                               Ksp, vector.ToArray(),
+                               Availability, RentingRatio, MinSpeed, MaxSpeed, DistanceType);
     }
 
Index: branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/Problems/TourProfitProblem.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/Problems/TourProfitProblem.cs	(revision 14628)
+++ branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/Problems/TourProfitProblem.cs	(revision 14629)
@@ -78,6 +78,6 @@
     public override double Evaluate(Individual individual, IRandom random) {
       return TtpUtils.Evaluate(Tsp, individual.Permutation().ToArray(),
-                                  Ksp, FixedKspSolution.ToArray(),
-                                  Availability, RentingRatio, MinSpeed, MaxSpeed, DistanceType);
+                               Ksp, FixedKspSolution.ToArray(),
+                               Availability, RentingRatio, MinSpeed, MaxSpeed, DistanceType);
     }
 
Index: branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork3.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork3.cs	(revision 14628)
+++ branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpNetwork3.cs	(revision 14629)
@@ -38,5 +38,5 @@
     public TtpNetwork3() : this("TtpNetwork3") { }
     public TtpNetwork3(string name) : base(name) {
-      Orchestrator = new TtpOrchestratorNode2(OrchestratorNodeName);
+      Orchestrator = new TtpOrchestratorNode3(OrchestratorNodeName);
       MetaSolver = new OrchestratedAlgorithmNode(MetaSolverNodeName);
       TspSolver = new OrchestratedAlgorithmNode(TspSolverNodeName);
Index: branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpOrchestratorNode3.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpOrchestratorNode3.cs	(revision 14628)
+++ branches/OptimizationNetworks/HeuristicLab.Networks.IntegratedOptimization.TravelingThief/3.3/TtpOrchestratorNode3.cs	(revision 14629)
@@ -27,5 +27,4 @@
 using HeuristicLab.Data;
 using HeuristicLab.Encodings.BinaryVectorEncoding;
-using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Encodings.RealVectorEncoding;
 using HeuristicLab.Optimization;
@@ -101,23 +100,12 @@
       var tspMsg = TspSolverOrchestrationPort.PrepareMessage();
       tspMsg["OrchestrationMessage"] = new EnumValue<OrchestrationMessage>(OrchestrationMessage.Prepare | OrchestrationMessage.ClearRuns | OrchestrationMessage.Start);
-      var tpp = new TourProfitProblem {
-        Tsp = (TravelingSalesmanProblem)TspParameter.Value.Clone(),
-        Ksp = (BinaryKnapsackProblem)KspParameter.Value.Clone(),
-        FixedKspSolution = bestKspSolution,
-        Availability = AvailabilityParameter.Value.ToArray(),
-        RentingRatio = RentingRatioParameter.Value.Value,
-        MinSpeed = MinSpeedParameter.Value.Value,
-        MaxSpeed = MaxSpeedParameter.Value.Value,
-        DistanceType = distanceType
-      };
-      tpp.Encoding.Length = TspParameter.Value.Coordinates.Rows;
-      tspMsg["Problem"] = tpp;
+      tspMsg["Problem"] = tsp;
       TspSolverOrchestrationPort.SendMessage(tspMsg);
       cts.Token.ThrowIfCancellationRequested();
 
       var tspResults = (ResultCollection)tspMsg["Results"];
-      var bestTspSolution = (Permutation)tspResults["Best TSP Solution"].Value.Clone();
+      var bestTspSolution = (PathTSPTour)tspResults["Best TSP Solution"].Value.Clone();
       var coordinates = (DoubleMatrix)TspParameter.Value.Coordinates.Clone();
-      var tour = new PathTSPTour(coordinates, bestTspSolution, new DoubleValue(TSPCoordinatesPathEvaluator.Apply(new TSPEuclideanPathEvaluator(), coordinates, bestTspSolution)));
+      var tour = new PathTSPTour(coordinates, bestTspSolution.Permutation, new DoubleValue(TSPCoordinatesPathEvaluator.Apply(new TSPEuclideanPathEvaluator(), coordinates, bestTspSolution.Permutation)));
 
       #region Analyze